package com.foo;

import org.apache.wicket.request.mapper.parameter.PageParameters;
import java.util.Arrays;
import org.apache.wicket.extensions.markup.html.repeater.data.table.IColumn;
import org.apache.wicket.extensions.markup.html.repeater.data.table.PropertyColumn;
import org.apache.wicket.model.Model;
import org.apache.wicket.extensions.markup.html.repeater.data.table.DefaultDataTable;
import org.apache.wicket.extensions.markup.html.repeater.util.SortableDataProvider;

import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.WebPage;
import org.apache.wicket.spring.injection.annot.SpringBean;

import com.foo.domain.ContactDao;

public class HomePage extends WebPage {
	private static final long serialVersionUID = 1L;
	
	@SpringBean
	private ContactDao dao;
	
	
    public HomePage(final PageParameters parameters) {
		add(new Label("version", getApplication().getFrameworkSettings().getVersion()));
		
		IColumn<?>[] cols = new IColumn[4];
		cols[0] = new PropertyColumn(new Model<String>("first name"), "firstName", "firstName");
		cols[1] = new PropertyColumn(new Model<String>("last name"), "lastName","lastName");
		cols[2] = new PropertyColumn(new Model<String>("home phone"), "homePhone");
		cols[3] = new PropertyColumn(new Model<String>("cell phone"), "cellPhone");

		add(new DefaultDataTable("contacts", Arrays.asList(cols), getDataProvider(), 10));
    }
    
	private SortableDataProvider<?> getDataProvider()
	{
		return new ProxyDataProvider(dao);
	}
}
