package com.foo;


import java.util.Iterator;

import org.apache.wicket.extensions.markup.html.repeater.data.sort.SortOrder;
import org.apache.wicket.extensions.markup.html.repeater.util.SortableDataProvider;
import org.apache.wicket.model.IModel;

import com.foo.domain.Contact;
import com.foo.domain.ContactDao;

public class ProxyDataProvider extends SortableDataProvider
{
	private static final long serialVersionUID = 1L;
	private ContactDao dao;

	public ProxyDataProvider(ContactDao dao)
	{
		this.dao = dao;
		setSort("firstName", SortOrder.ASCENDING);
	}

	protected ContactDao getContactDao()
	{
		return dao;
	}

	public IModel model(Object object)
	{
		return new ProxyModel((Contact)object, dao);
	}
	
	public final Iterator iterator(int first, int count)
	{
		QueryParam qp = new QueryParam(first, count, getSort());
		return getContactDao().find(qp);
	}
	
	public final int size()
	{
		return getContactDao().count();
	}
	
}
