package com.foo;



import org.apache.wicket.extensions.markup.html.repeater.util.SortParam;

/**
 * Encapsulates the Query Paramaters to be passed to daos
 * 
 * @author Igor Vaynberg (ivaynberg)
 */
public class QueryParam
{
	private int first;

	private int count;

	private SortParam sort;

	/**
	 * Set to return <tt>count</tt> elements, starting at the <tt>first</tt> element.
	 * 
	 * @param first
	 *            First element to return.
	 * @param count
	 *            Number of elements to return.
	 */
	public QueryParam(int first, int count)
	{
		this(first, count, null);
	}

	/**
	 * Set to return <tt>count</tt> sorted elements, starting at the <tt>first</tt> element.
	 * 
	 * @param first
	 *            First element to return.
	 * @param count
	 *            Number of elements to return.
	 * @param sort
	 */
	public QueryParam(int first, int count, SortParam sort)
	{
		this.first = first;
		this.count = count;
		this.sort = sort;
	}

	public int getCount()
	{
		return count;
	}

	public int getFirst()
	{
		return first;
	}

	public SortParam getSort()
	{
		return sort;
	}

	public boolean hasSort()
	{
		return sort != null;
	}

}
