package com.foo.domain;

import java.util.Iterator;

import com.foo.QueryParam;



/**
 * interface for retrieving contacts from a database
 * 
 * @author Igor Vaynberg (ivaynberg)
 * 
 */
public interface ContactDao
{
	/**
	 * @return total number of contacts available
	 */
	int count();

	/**
	 * @param qp
	 *            sorting and paging info
	 * @return iterator over contacts
	 */
	Iterator find(QueryParam qp);

	/**
	 * @param id
	 *            contact id
	 * @return contact with matching id
	 */
	Contact get(long id);
}